import static java.lang.Math.*;


public class springFunc{
    static vectorFunc v = new vectorFunc();;
    static atomFunc a = new atomFunc();;
    
    public static vector springForces(spring s, atom[] atomLst)    // return self repulsion spring+damper forces
    {
        float distCenters = a.distanceCenters(atomLst[s.i], atomLst[s.j]);  // returns distance, 
        float restlenght = a.sizes(atomLst[s.i], atomLst[s.j]);
        vector link = v.sub(atomLst[s.i].pos, atomLst[s.j].pos);
        double mult = restlenght / (float)sqrt(distCenters);
        float comp = (atomLst[s.i].mass*atomLst[s.j].mass)/(atomLst[s.i].mass+atomLst[s.j].mass);
        
        vector spring = v.scale(v.sub(v.scale(link, mult), link), comp*220000); // dist=distance surface to surface. (how deep) K=5000
        vector damper = v.scale((v.sub(atomLst[s.j].vel, atomLst[s.i].vel)), 10);            // D=damping
        return v.add(spring, damper);
    }
    
    //usage
    //springLst = s.insert(springLst, nuspring
    //return new updated spring list
    public static spring insert(spring springLst, spring nuspring)
    {
        nuspring.next = springLst;
        return nuspring;
    }
    
    //usage in world
    //atomLst = iterate(springLst, atomLst)
    //return new updated atom list
    public static atom[] iterateForce(spring sprCur, atom [] atomLst, int atomQty)
    {
        //create new list
        atom nuatomLst[] = new atom[atomQty];
        for (int i=0;i<atomQty;i++)
            nuatomLst[i] = atomLst[i];
        //here is the function
        vector tmpForce = springForces(sprCur, atomLst);
        nuatomLst[sprCur.i] = a.subforce(nuatomLst[sprCur.i], tmpForce);
        nuatomLst[sprCur.j] = a.addforce(nuatomLst[sprCur.j], tmpForce);
        //not sure what to do about breakage
        //but cant be done here
        //this is recursive loop... trolololo
        if (sprCur.next != null)
            return iterateForce(sprCur.next, nuatomLst, atomQty);
        //return the list
        return nuatomLst;
    }
    
    //usage
    //springLst = pete(springToPete)
    //list will be null if none left
    public static spring pete(spring sprCur)
    {
        // double linked list
        // a <=> b <=> c
        // remove b
        // a->next = b-> next :::: while a =  b->back, then b->back->next = b->next
        // something alike with c
        // a <=> c
        if (sprCur.next != null)
            sprCur.next.back = sprCur.back;
        if (sprCur.back != null)
        {
            sprCur.back.next = sprCur.next;
            while(sprCur.back != null)
                sprCur = sprCur.back;
            return sprCur;
        }
        return sprCur.next;
    }
    
    //simple iterator
    //usage
    //sprLoop = next(sprLoop);
    public static spring next(spring sprCur)
    {
        return sprCur.next;
    }
}
